
 //!!!<<<<<<<<<<<<   Ball.c by Micha Wsowicz   >>>>>>>>>>>>!!!//

/*****************************************************************/
/* This program demonstrates my favourite page flipping and some */
/* graphics routines. 
#define MIN_X 9
#define MIN_Y 33
#define MAX_X 311
#define MAX_Y 192

#define RED    1
#define GREEN  2
#define YELLOW 3
#define BLUE   4
#define BLACK  255

#include <stdlib.h>
#include <stdio.h>

#include "allegro.h"          // I almost always use ALLEGRO
                              // by Shawn Hargreaves.
void main()
{
  BITMAP *page1, *page2;     // Two sub-bitmaps for page flipping.
  BITMAP *active_page;
  int x = 80;
  int y = 50;
  int vx = 1;
  int vy = 1;
  int x_velocity = 10;
  int y_velocity = 10;
  int x_speed = 1;
  int y_speed = 1;
  int color = BLACK;
  char buf[80];
  
   allegro_init();
   install_timer();
   install_keyboard();

/* Create a virtual screen for page flipping. */
   set_gfx_mode(GFX_MODEX, 320, 240, 0, 400);

   set_pallete(desktop_pallete);

   page1 = create_sub_bitmap(screen, 0, 0, SCREEN_W, SCREEN_H);
   page2 = create_sub_bitmap(screen, 0, SCREEN_H, SCREEN_W, SCREEN_H);
   active_page = page2;

for(;;)
{
 clear(active_page);

/*      Colorful lines making a rectangle inside which
        the ball will be moving.          */
 hline(active_page, 1, 25, 318, YELLOW);
 hline(active_page, 1, 199, 318, RED);
 vline(active_page, 1, 26, 199, GREEN);
 vline(active_page, 319, 26, 199, BLUE); 

/* Our ball */
 circlefill(active_page, x, y, 8, color);

/* Print the horizontal and vertical velocities as positive numbers */
 if(vx >= 0)
  x_speed = vx;
 else
  x_speed = -vx;

 if(vy >= 0)
  y_speed = vy;
 else
  y_speed = -vy;

 sprintf(buf,"horizontal velocity = %d", x_speed);
 textout(active_page, font, buf, 20, 5, BLACK);
 sprintf(buf," vertical  velocity = %d", y_speed);
 textout(active_page, font, buf, 20, 15, BLACK);

/* Change the position of the ball. */
 x += vx;
 y += vy;
 
/* The ball deflects and changes the color after hitting a wall. */
if(x >= MAX_X)
 {     vx = -vx;
  x_velocity = -x_velocity;
  color = BLUE;  }

if(x <= MIN_X)
 {     vx = -vx;
  x_velocity = -x_velocity;
  color = GREEN;  }

if(y >= MAX_Y)
 {     vy = -vy;
  y_velocity = -y_velocity;
  color = RED;  }

if(y <= MIN_Y)
 {    vy = -vy;
  y_velocity = -y_velocity;
  color = YELLOW;   }

/* You can adjust the speed using arrow keys. */
/*!!!!!!!!!!!!!!!!!!!!!!      ATTENTION     !!!!!!!!!!!!!!!!!!!!!!!*/
/* I didn't use y_velicity and x_velocity variables to complicate
the code. It gives more control over the arrows besause the speed 
is changed slowly. Adjusting diredtly vx and vy would be too fast. */

 if (key[KEY_UP])
 { if(y_velocity >= 0)
  y_velocity++;
   else
  y_velocity--; 
   vy = (y_velocity - y_velocity % 10) / 10;    }
 
 if (key[KEY_DOWN])
 { if(y_velocity >= 0)
  y_velocity--;
   else
  y_velocity++; 
   vy = (y_velocity - y_velocity % 10) / 10;   }      

 if (key[KEY_LEFT])
 { if(x_velocity >= 0)
  x_velocity--;
   else
  x_velocity++;
   vx = (x_velocity - x_velocity % 10) / 10;    }

 if (key[KEY_RIGHT])
 { if(x_velocity >= 0)
  x_velocity++;
   else
  x_velocity--;
    vx = (x_velocity - x_velocity % 10) / 10;   }

  
       if (active_page == page1) {
	 scroll_screen(0, 0);
	 active_page = page2;
      }
      else {
	 scroll_screen(0, SCREEN_H);
	 active_page = page1;
      }

 if (key[KEY_ESC])  {
   destroy_bitmap(page1);
   destroy_bitmap(page2);
   exit(0);  }
 }
}

